<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\React\CommandBus\CommandBus;
use NoccyLabs\React\CommandBus\CommandRegistry;
use NoccyLabs\React\CommandBus\Context;
use React\EventLoop\Loop;
use React\Promise\Promise;

$commands = new CommandRegistry();
// Register some function to call. The name here is "hello", and it will
// receive a Context holding the call context. Any passed data will be
// available as properties on the Context object.
$commands->register("hello", function (Context $context) {
    // You don't have to, but you should return a promise from your 
    // commands.
    return new Promise(function (callable $resolve) use ($context) {
        Loop::addTimer(1, function () use ($context, $resolve) {
            $resolve("Hello, {$context->name}");
        });
    });
});
$commands->register("hello2", function (Context $context) {
    // Just returning the value works just fine!
    return "Hello2, {$context->name}";
});

// Create the bus
$bus = new CommandBus($commands);

// And execute some commands!
$bus->execute('hello', ['name'=>'Bob'])->then(
    function ($result) {
        var_dump($result);
    }
);

$bus->execute('hello2', ['name'=>'Bob'])->then(
    function ($result) {
        var_dump($result);
    }
);
